% some math predicates

:- class('MyMath').


d(X,X,1).
d(C,X,0):-atomic(C).
d(U+V,X,A+B):-d(U,X,A),d(V,X,B).
d(U-V,X,A-B):-d(U,X,A),d(V,X,B).
d(C*U,X,C*A):-atomic(C), not(C=X), d(U,X,A).
d(U*V,X,B*U+A*V):-d(U,X,A),d(V,X,B).
d(exp(U,C),X,exp(U,C-1)*W*(C-1)):-atomic(C),not(C=X),d(U,X,W).
d(log(U),X,A*exp(U,-1)):-d(U,X,A).
%%d(U/V,X,A):-d(U*exp(V,-1),X,A).
%%d(-U,X,-A):-d(U,X,A).

factorialx(0,1).
factorialx(N,F) :- N > 0, M is N - 1, factorialx(M,Fm), F is N * Fm.

fib(0,1).
fib(1,1).
fib(N,F) :- N > 1, N1 is N - 1, N2 is N - 2, fib(N1,F1), fib(N2,F2), F is F1 + F2.

min(M,N,M) :- M < N.
min(M,N,N) :- N < M.

